module Csound.Typed.Plugins(
    adsr140,
    audaciousEq,
    
    -- Solina chorus
    solinaChorus, testSolinaChorus,

    -- One pole filters
    zdf1, zlp1, zhp1, zap1,

    -- Two pole filters
    zdf2, zlp, zbp, zhp, zdf2_notch, zbr,

    -- Ladder filter
    zladder, 

    -- Four poles filters
    zdf4, zlp4, zbp4, zhp4, 

    -- Eq-filters
    peakEq, highShelf, lowShelf,

    -- Diode ladder filters
    diode, linDiode, noNormDiode,

    -- Korg 35 filters
    linKorg_lp, linKorg_hp, korg_lp, korg_hp,

    -- zero delay convolution
    ZConvSpec(..), zconv, zconv'
) where

import Csound.Typed.Plugins.Adsr140
import Csound.Typed.Plugins.Zdf
import Csound.Typed.Plugins.Diode
import Csound.Typed.Plugins.Audaciouseq
import Csound.Typed.Plugins.Korg35
import Csound.Typed.Plugins.SolinaChorus
import Csound.Typed.Plugins.ZeroDelayConvolution